lab_1/urls.py
from django.conf.urls import url
from .views import index
#url for app
urlpatterns = [
    url(r'^$', index, name='index'),
]

lab_7/urls.py
from django.conf.urls import url
from .views import index, add_friend, validate_npm, delete_friend, friend_list, get_friend_list

urlpatterns = [
		url(r'^$', index, name='index'),
		url(r'^add-friend/$', add_friend, name='add-friend'),
		url(r'^validate-npm/$', validate_npm, name='validate-npm'),
		url(r'delete-friend/(?P<friend_id>[0-9]+)/$', delete_friend, name='delete-friend'),
		url(r'^friend-list/$', friend_list, name='friend-list'),
		url(r'^get-friend-list/$', get_friend_list, name='get-friend-list'),

]

praktikum/urls.py
from django.conf.urls import url, include
from django.contrib import admin
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_2_addon.urls as lab_2_addon
import lab_3.urls as lab_3
import lab_4.urls as lab_4
from django.views.generic import RedirectView
from lab_1.views import index as index_lab1
import lab_5.urls as lab_5
import lab_6.urls as lab_6
import lab_7.urls as lab_7
import lab_8.urls as lab_8
import lab_9.urls as lab_9
import lab_10.urls as lab_10


urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^lab-1/', include(lab_1,namespace='lab-1')),
    url(r'^lab-2/', include(lab_2,namespace='lab-2')),
    url(r'^lab-2-addon/', include(lab_2_addon,namespace='lab-2-addon')),
    url(r'^lab-3/', include(lab_3,namespace='lab-3')),
    url(r'^lab-4/', include(lab_4,namespace='lab-4')),
    url(r'^lab-5/', include(lab_5, namespace='lab-5')),
    url(r'^lab-6/', include(lab_6, namespace='lab-6')),
    url(r'^lab-7/', include(lab_7, namespace='lab-7')),
    url(r'^lab-8/', include(lab_8, namespace='lab-8')),
    url(r'^lab-9/', include(lab_9, namespace='lab-9')),
    url(r'^lab-10/', include(lab_10, namespace='lab-10')),
    url(r'^$', RedirectView.as_view(url='/lab-10/', permanent = True)),
]

lab_7/models.py
from django.db import models

# Create your models here.
class Friend(models.Model):
        friend_name = models.CharField(max_length=400)
        npm = models.CharField(max_length=250)
        alamat = models.CharField(max_length=400, default="-")
        ttl = models.CharField(max_length=400, default="-")
        prodi = models.CharField(max_length=100, default="-")
        added_at = models.DateField(auto_now_add=True)

lab_7/views.py
from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect, JsonResponse
from django.views.decorators.csrf import csrf_exempt
from django.core import serializers
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger

from .models import Friend
from .api_csui_helper.csui_helper import CSUIhelper
import os
import json

response = {}
csui_helper = CSUIhelper()

def index(request):
	# Page halaman menampilkan list mahasiswa yang ada
	# TODO berikan akses token dari backend dengan menggunakaan helper yang ada
	mahasiswa_list = csui_helper.instance.get_mahasiswa_list()
	friend_list = Friend.objects.all()
	auth = csui_helper.instance.get_auth_param_dict()
	#Paginator
	page = request.GET.get('page', 1)
	paginate_data = paginate_page(page, mahasiswa_list)
	mahasiswa = paginate_data['data']
	page_range = paginate_data['page_range']

	response = {"mahasiswa_list": mahasiswa, "friend_list": friend_list, "page_range": page_range, "auth": auth}
	html = 'lab_7/lab_7.html'
	return render(request, html, response)

def paginate_page(page, data_list):
	paginator = Paginator(data_list, 10)

	try:
		data = paginator.page(page)
	except PageNotAnInteger:
		data = paginator.page(1)
	except EmptyPage:
		data = paginator.page(paginator.num_pages)

	# Get the index of the current page
	index = data.number - 1
	# This value is maximum index of your pages, so the last page - 1
	max_index = len(paginator.page_range)
	# You want a range of 10, so lets calculate where to slice the list
	start_index = index if index >= 10 else 0
	end_index = 10 if index < max_index - 10 else max_index
	# Get our new page range. In the latest versions of Django page_range returns 
	# an iterator. Thus pass it to list, to make our slice possible again.
	page_range = list(paginator.page_range)[start_index:end_index]
	paginate_data = {'data':data, 'page_range':page_range}
	return paginate_data

def friend_list(request):
    friend_list = Friend.objects.all()
    response['friend_list'] = friend_list
    html = 'lab_7/daftar_teman.html'
    return render(request, html, response)

def get_friend_list(request):
	if request.method == 'GET':
		friend_list = Friend.objects.all()
		data = serializers.serialize('json', friend_list)
		return HttpResponse(data)

@csrf_exempt
def add_friend(request):
    if request.method == 'POST':
        name = request.POST['name']
        npm = request.POST['npm']
        alamat = request.POST['alamat']
        ttl = request.POST['ttl']
        prodi = request.POST['prodi']
        taken = Friend.objects.filter(npm__iexact=npm).exists()
        if(not taken):
        	friend = Friend(friend_name=name, npm=npm, alamat=alamat, ttl=ttl, prodi=prodi)
        	friend.save()
        data = model_to_dict(friend)
        return HttpResponse(data)

def delete_friend(request, friend_id):
	Friend.objects.filter(id=friend_id).delete()
	return HttpResponseRedirect('/lab-7/friend-list')

@csrf_exempt
def validate_npm(request):
    npm = request.POST.get('npm', None)
    data = {
        'is_taken': Friend.objects.filter(npm__iexact=npm).exists() #lakukan pengecekan apakah Friend dgn npm tsb sudah ada
    }
    return JsonResponse(data)


def model_to_dict(obj):
    data = serializers.serialize('json', [obj,])
    struct = json.loads(data)
    data = json.dumps(struct[0]["fields"])
    return data

lab_7/templates/lab_7/daftar_teman.html
{% extends "lab_7/layout/base.html" %}

{% block content %}
    <section name="friend-list" class="friend-list">
        <div class="container">
            <div class="row">
                <div class="col-md-8 col-lg-8">
                    <h2>Fasilkom Friends</h2>
                    <div id="friend-list" class="list-group">
                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}
{% block javascript %}
    <script>
        $( document ).ready(function () {
            // {# lengkapi pemanggilan ajax berikut untuk mengambil daftar teman yang ada di database #}
            $.ajax({
                method: "GET",
                url: '{% url "lab-7:get-friend-list" %}',//#URL untuk mendapatkan list teman,
                success: function (friend_list) {
                    console.log(friend_list)
                    var list = JSON.parse(friend_list);
                    // #tampilkan list teman ke halaman
                    // #hint : gunakan fungsi jquery append()
                    if(list.length==0) {
                        var html = '<div class="alert alert-danger text-center">\
                            <strong>Oops!</strong> Tidak ada teman\
                            </div>';
                        $("#friend-list").append(html)
                    }
                    else {
                        $.each(list, function(index, friend) {
                            var button = '<span class="pull-right">'+
                                            '<button type="button" class="btn btn-xs btn-danger"'+
                                            'onClick="deleteFriend('+friend.pk+')">'+
                                                '&times;'+
                                            '</button>'+
                                         '</span>';

                            var html = '<a class="list-group-item clearfix">'+
                                        friend.fields.friend_name +
                                        ' (' + friend.fields.npm + ')'+  button +  '</a>';
                            $("#friend-list").append(html)
                        });
                    }
                }
            });
        });

        const deleteFriend = function(id) {
           window.open('delete-friend/'+id+'/', '_self');
        }

    
    </script>
{% endblock %}

lab_7/templates/lab_7/lab_7.html
{% extends "lab_7/layout/base.html" %}
{% block content %}
<section name="mahasiswa-list" id="mahasiswa-list">
    <div class="container">
        <div class="row">
            <div class="col-md-8 col-lg-8">
                <h2> Mahasiswa Fasilkom</h2>
                <div class="list-group">
                    {% if mahasiswa_list %}
                        {% for mahasiswa in mahasiswa_list %}
                            <a class="list-group-item clearfix">
                                {{ mahasiswa.nama }} ({{ mahasiswa.npm }})
                                <span class="pull-right">
                                    <span class="btn btn-xs btn-default" onClick="addFriend('{{ mahasiswa.nama }}', '{{ mahasiswa.npm }}', '{{ mahasiswa.alamat_mhs }}', '{{ mahasiswa.kota_lahir }}, {{ mahasiswa.tgl_lahir }}', '{{ mahasiswa.program.0.nm_org }} ({{ mahasiswa.program.0.nm_prg }})')">
                                        Tambah sebagai teman
                                    </span>
                                </span>
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Oops!</strong> Tidak ada mahasiswa
                        </div>
                    {% endif %}
                    {% if mahasiswa_list.has_other_pages %}
                        <ul class="pagination">
                            {% if mahasiswa_list.has_previous %}
                                <li><a href="{% url 'lab-7:index' %}">&laquo;</a></li>
                                <li><a href="?page={{ mahasiswa_list.previous_page_number }}">&lsaquo;</a></li>
                            {% else %}
                                <li class="disabled"><span>&lsaquo;</span></li>
                            {% endif %}
                            {% for page in page_range %}
                                {% if mahasiswa_list.number == page %}
                                    <li class="active"><span>{{ page }} <span class="sr-only">(current)</span></span></li>
                                {% else %}
                                    <li><a href="?page={{ page }}">{{ page }}</a></li>
                                {% endif %}
                            {% endfor %}
                            {% if mahasiswa_list.has_next %}
                                <li><a href="?page={{ mahasiswa_list.next_page_number }}">&rsaquo;</a></li>
                                <li><a href="?page={{ mahasiswa_list.paginator.num_pages }}">&raquo;</a></li>
                            {% else %}
                                <li class="disabled"><span>&rsaquo;</span></li>
                            {% endif %}
                        </ul>
                    {% endif %}
                </div>
                {% if auth %}
                    <div id="token" hidden="true">{{ auth.access_token }}</div>
                    <div id="cid" hidden="true">{{ auth.client_id }}</div>
                {% endif %}
            </div>
            <div class="col-lg-4">
                <h2> Teman Saya </h2>
                <div class="list-group" id="friend-list">
                    {% if friend_list %}
                        {% for friend in friend_list %}
                            <a class="list-group-item clearfix">
                                {{ friend.friend_name }} ({{ friend.npm }})
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Oops!</strong> Tidak ada teman
                        </div>
                    {% endif %}
                </div>
                <form id="add-friend" action="#">
                    {% csrf_token %}
                    <label for="field_npm">NPM:</label>
                    <input id="field_npm" type="text" name="npm" class="form-control"/>
                    <label for="field_name">Name:</label>
                    <input id="field_name" type="text" name="name" class="form-control"/>
                    <button type="submit">Tambah</button>
                </form>
            </div>
        </div>
    </div>
</section>
{% endblock %}
{% block javascript %}
<script>
    var token = document.getElementById("token").innerHTML;
    var cid = document.getElementById("cid").innerHTML;
    var addFriend = function(nama, npm, alamat, ttl, prodi) {
        $.ajax({
            method: "POST",
            url: '{% url "lab-7:add-friend" %}',
            data: { name: nama, npm: npm, alamat: alamat, ttl: ttl, prodi: prodi},
            success : function (friend) {
                html = '<a class="list-group-item clearfix">' +
                        nama + ' (' + npm +')</a>';
                $("#friend-list").append(html)
            },
            error : function (error) {
                alert("Mahasiswa tersebut sudah ditambahkan sebagai teman")
            }
        });
    };

    $("#add-friend").on("submit", function (event) {
        var npm = $("#field_npm").val();
        var corsProxy = 'https://cors-anywhere.herokuapp.com/';
        var obj = new Object(); obj.access_token = token; obj.client_id = cid;
        var param = $.param(obj);
        $.ajax({
            method: "GET",
            url: corsProxy+'https://api-dev.cs.ui.ac.id/siakngcs/mahasiswa/'+npm+'/?'+param,
            success: function(data) {
                addFriend(data.nama, data.npm, data.alamat_mhs,
                          data.kota_lahir+", "+data.tgl_lahir,
                          data.program[0].nm_org+" ("+data.program[0].nm_prg+")"
                )
            },
            error: function(error) {
                console.log(error)
                alert("\n\t\t\tNPM tidak valid:\n\n'Tidak ada mahasiswa dengan NPM tersebut'")
            }
        });
        event.preventDefault();
    });

    $("#field_npm").change(function () {
        console.log( $(this).val() );
        npm = $(this).val();
        $.ajax({
            method: "POST",
            url: '{% url "lab-7:validate-npm" %}',
            data: {
                'npm': npm
            },
            dataType: 'json',
            success: function (data) {
                console.log(data)
                if (data.is_taken) {
                    alert("Mahasiswa dengan NPM tersebut sudah menjadi teman");
                }
            }
        });
    });
</script>
{% endblock %}